<?php

namespace Drupal\video_embed_html5\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * A Html5 provider plugin.
 *
 * @VideoEmbedProvider(
 *   id = "html_5",
 *   title = @Translation("HTML5")
 * )
 */
class Html5 extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    list($video_url, $video_type) = $this->getVideoId();
    return [
      '#theme' => 'video_embed_html5',
      '#src' => $video_url,
      '#type' => 'video/' . $video_type,
      '#autoplay' => $autoplay,
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getRemoteThumbnailUrl() {
    throw new \Exception('HTML5 provider does not currently support thumbnails.');
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    $pattern = "/\b(http|https):\/\/.*(mp4|ogg|webm)\b/";
    $matches = array();
    preg_match($pattern, $input, $matches);

    // Make sure there are values.
    if ($matches && isset($matches[2])) {
      return array($input, $matches[2]);
    }

    return FALSE;
  }
}
